/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or glassfish/bootstrap/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at glassfish/bootstrap/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

/*
 * PolicySuite.java
 * JUnit based test
 *
 * Created on August 24, 2006, 12:28 AM
 */

package com.sun.xml.ws.security.impl.policy;

import junit.framework.*;

/**
 *
 * @author mayank
 */
public class PolicySuite extends TestCase {
    
    public PolicySuite(String testName) {
        super(testName);
    }

    protected void setUp() throws Exception {
    }

    protected void tearDown() throws Exception {
    }

    /**
     * suite method automatically generated by JUnit module
     */
    public static Test suite() {
        TestSuite suite = new TestSuite("PolicySuite");
        suite.addTest(com.sun.xml.ws.security.impl.policy.AsymmetricBindingTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.EncryptedPartsTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.EncryptedSupportingTokensTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.EndorsingEncryptedSupportingTokensTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.EndorsingSupportingTokensTest.suite());   
	suite.addTest(com.sun.xml.ws.security.impl.policy.HttpsTokenTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.IssuedTokenTest.suite());     
        suite.addTest(com.sun.xml.ws.security.impl.policy.KerberosTokenTest.suite()); 
        suite.addTest(com.sun.xml.ws.security.impl.policy.KeyValueTokenTest.suite()); 
        suite.addTest(com.sun.xml.ws.security.impl.policy.RelTokenTest.suite());      
        suite.addTest(com.sun.xml.ws.security.impl.policy.SamlTokenTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SecureConversationTokenTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SecurityContextTokenTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SecurityPoliciesTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SignedElementsTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SignedEncryptedSupportingTokensTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SignedEndorsingEncryptedSupportingTokensTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SignedEndorsingSupportingTokensTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SignedPartsTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SignedSupportingTokensTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SpnegoContextTokenTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SupportingTokensTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.SymmetricBindingTest.suite());
        suite.addTest(com.sun.xml.ws.security.impl.policy.TransportBindingTest.suite());  
        suite.addTest(com.sun.xml.ws.security.impl.policy.UsernameTokenTest.suite());     
        suite.addTest(com.sun.xml.ws.security.impl.policy.X509TokenTest.suite());
        return suite;
    }
    
}
